/**
 * @author 2016.03 Yongjoo Cho
 */


public class TCPServerTest 
{
    public static final int BUFFER_SIZE = 512;
    TCPServer server = null;
    TCPClient client = null;
    byte[] sendData;
    byte[] receiveData;
    char[] tempCharData;
  
    TCPServerTest(int port) {
        server = new TCPServer();
        server.init(port);
        sendData = new byte[BUFFER_SIZE];
        receiveData = new byte[BUFFER_SIZE];
        tempCharData = new char[BUFFER_SIZE];
    }
  
    public void paddingBytesArray(byte[] dest, int newSize, byte[] src, int size) {
	    for (int i = 0; i < size; i++) {
		    dest[i] = src[i];
	    }
	    for (int i = size; i < newSize; i++) {
		    dest[i] = 0;
	    }
    }
  
    public void send(String s) {
        if (client != null) {
            paddingBytesArray(sendData, BUFFER_SIZE, s.getBytes(), s.length());
            client.write(sendData, BUFFER_SIZE, true);	
	    }
    }

    public void listen() {
	    client = server.checkForNewConnections();
    }
  
    public void receive() {
	    if (client != null) {
		    client.read(receiveData, BUFFER_SIZE, true);
        }
	    else {
		    System.out.println("Client is null");
	    }
    }

    public String getReceivedString() {
		int index;
		for (index = 0; index < receiveData.length; index++) {
			if (receiveData[index] != 0)
				tempCharData[index] = (char) receiveData[index];
			else 
				break;  // null character is hit			
		}
		String s = new String(tempCharData, 0, index);
		return s;
	}

    public static void main(String[] args) {
	    TCPServerTest t = new TCPServerTest(Integer.parseInt(args[0]));
	    t.listen();
   	    while (true) {
		    t.receive();
			String s = t.getReceivedString();
			System.out.println(s);
		    t.send("Received: " + s);
        }
    }
}