import java.util.Scanner;
 
public class UDPClientTest {
	UDPSocket client;
	byte[] sendData;
    char[] tempCharData;
    public static final int BUFFER_SIZE = 512;
	
	UDPClientTest(String dest, int port) {
        client = new UDPSocket();
        client.setSendAddress(dest, port);
		sendData = new byte[BUFFER_SIZE];
        tempCharData = new char[BUFFER_SIZE];
	}

    public void paddingBytesArray(byte[] dest, int newSize, byte[] src, int size) {
        for (int i = 0; i < size; i++) {
		    dest[i] = src[i];
        }
        for (int i = size; i < newSize; i++) {
            dest[i] = 0;
	    }
    }
  
    public String getReceivedString(byte[] receiveData) {
		int index;
		for (index = 0; index < receiveData.length; index++) {
			if (receiveData[index] != 0)
				tempCharData[index] = (char) receiveData[index];
			else 
				break;  // null character is hit			
		}
		String s = new String(tempCharData, 0, index);
		return s;
	}
    
    public void send(String s) {
        if (client != null) {
	        paddingBytesArray(sendData, BUFFER_SIZE, s.getBytes(), s.length());
            client.send(sendData, BUFFER_SIZE);
	    }
    }
    
    public byte[] receive() {
        byte[] b = client.receive(BUFFER_SIZE);
        return b;
    }
  
    public static void main(String[] args) {
        UDPClientTest t = new UDPClientTest(args[0], Integer.parseInt(args[1]));
		
	    Scanner input = new Scanner(System.in);
	    String text = "";
	    while (text.compareTo("EXIT") != 0) {
		    System.out.print("Type your text: ");
		    text = input.nextLine();
		    t.send(text);	  
            byte[] b = t.receive();
            String s = t.getReceivedString(b);
            System.out.println(s);
	    }
    }
} 
 
