import java.io.*;
import java.net.*;
import java.util.Date;
 
public class UDPServerTest {
    public static final int BUFFER_SIZE = 512;
    byte[] sendData;
    char[] tempCharData;
    UDPSocket server;
    
    public UDPServerTest(int port) {
        server = new UDPSocket(port);
        sendData = new byte[BUFFER_SIZE];
        tempCharData = new char[BUFFER_SIZE];
    }
       
    public void paddingBytesArray(byte[] dest, int newSize, byte[] src, int size) {
        for (int i = 0; i < size; i++) {
		    dest[i] = src[i];
        }
        for (int i = size; i < newSize; i++) {
            dest[i] = 0;
	    }
    }
  
    public String getReceivedString(byte[] receiveData) {
		int index;
		for (index = 0; index < receiveData.length; index++) {
			if (receiveData[index] != 0)
				tempCharData[index] = (char) receiveData[index];
			else 
				break;  // null character is hit			
		}
		String s = new String(tempCharData, 0, index);
		return s;
	}
    
    public void send(String s) {
        if (server != null) {
	        paddingBytesArray(sendData, BUFFER_SIZE, s.getBytes(), s.length());
            server.send(sendData, BUFFER_SIZE);
	    }
    }
    
    public byte[] receive() {
        byte[] b = server.receive(BUFFER_SIZE);
        return b;
    }
 
    public void copyReceiveAddressToSendAddress() {
        server.copyReceiveAddressToSendAddress();
    }
    
    public static void main(String[] args){
        UDPServerTest t = new UDPServerTest(Integer.parseInt(args[0]));
       
        while (true) {
            byte[] b = t.receive();
            String s = t.getReceivedString(b);
            System.out.println(s);
            String newString = "Received: " + s;
            t.copyReceiveAddressToSendAddress();
            t.send(newString);
        }
    }
} // UDPTimeServer
